/*
 * Copyright (c) 2004, Nate Nielsen
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 * 
 *     * Redistributions of source code must retain the above 
 *       copyright notice, this list of conditions and the 
 *       following disclaimer.
 *     * Redistributions in binary form must reproduce the 
 *       above copyright notice, this list of conditions and 
 *       the following disclaimer in the documentation and/or 
 *       other materials provided with the distribution.
 *     * The names of contributors to this software may not be 
 *       used to endorse or promote products derived from this 
 *       software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS 
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF 
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGE.
 * 
 *
 * CONTRIBUTORS
 *  Nate Nielsen <nielsen@memberwebs.com>
 *
 */ 
 
#ifndef __RTFFIXUPS_H__
#define __RTFFIXUPS_H__

#include "sablo.h"

class RtfFixups
{
public:
    // Cleanup Functions
    static void fixBlocks(DOM::Document doc);
    static void fixLists(const DOM::Document doc);
    static void fixStyles(const DOM::Document doc);
    static bool breakElement(const DOM::Element& el, const string& contain);
    static void breakBreak(DOM::Document& doc, const string& contain, const string& tag);
    static void breakLists(DOM::Document& document);
    static void breakTables(DOM::Document& document);
    static void breakTags(DOM::Document& doc, const string& parentName, const string& tagName);
    static void breakBlocks(DOM::Document& document);
    static void wrapTags(DOM::Document& document, const string& tagName, const string& wrapName);
    static void removeTags(const DOM::Document& doc);
    static void removeDuplicates(const DOM::Document& doc);
    static void consolidateStartTags(DOM::Document& doc);
    static void consolidateEndTags(DOM::Document& doc);
};

#endif // __RTFFIXUPS_H__
